/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Builder.xs. Do not edit this file, edit Builder.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "src/Builder.xs"
/*
 * Copyright (c) 2019, cPanel, L.L.C.
 * All rights reserved.
 * http://cpanel.net/
 *
 * This is free software; you can redistribute it and/or modify it under the
 * same terms as Perl itself.  See the Perl manual section 'perlartistic' for
 * further information.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include <sys/types.h>
#include <errno.h>
#include "b_string.h"
#include "b_find.h"
#include "b_error.h"
#include "b_builder.h"

typedef b_builder * Archive__Tar__Builder;

static int user_lookup(SV *cache, uid_t uid, gid_t gid, b_string **user, b_string **group) {
    dSP;
    I32 retc;

    ENTER;
    SAVETMPS;

    /*
     * Prepare the stack for $cache->getpwuid()
     */
    PUSHMARK(SP);
    XPUSHs(cache);
    XPUSHs(sv_2mortal(newSViv(uid)));
    XPUSHs(sv_2mortal(newSViv(gid)));
    PUTBACK;

    retc = call_method("lookup", G_ARRAY);

    SPAGAIN;

    if (retc < 2) {
        goto error_lookup;
    }

    if (retc == 2) {
        size_t len = 0;
        SV *item;
        char *tmp;

        if ((item = POPs) != NULL && SvOK(item)) {
            tmp = SvPV(item, len);

            if ((*group = b_string_new_len(tmp, len)) == NULL) {
                goto error_string_new_group;
            }
        }

        if ((item = POPs) != NULL && SvOK(item)) {
            tmp = SvPV(item, len);

            if ((*user = b_string_new_len(tmp, len)) == NULL) {
                goto error_string_new_user;
            }
        }
    }

    PUTBACK;

    FREETMPS;
    LEAVE;

    return 0;

error_string_new_user:
    b_string_free(*group);

error_string_new_group:

error_lookup:
    PUTBACK;

    FREETMPS;
    LEAVE;

    return -1;
}

static b_string *hardlink_lookup(SV *cache, dev_t dev, ino_t ino, b_string *path) {
    dSP;
    I32 retc;

    size_t len = 0;
    SV *item;
    char *tmp;

    ENTER;
    SAVETMPS;

    /*
     * Prepare the stack for $cache->lookup()
     */
    PUSHMARK(SP);
    XPUSHs(cache);
    XPUSHs(sv_2mortal(newSViv(dev)));
    XPUSHs(sv_2mortal(newSViv(ino)));
    XPUSHs(sv_2mortal(newSVpv(path->str, path->len)));
    PUTBACK;

    path = NULL;
    retc = call_method("lookup", G_ARRAY);

    SPAGAIN;

    if (retc != 1) {
        goto leave;
    }

    if ((item = POPs) != NULL && SvOK(item)) {
        tmp = SvPV(item, len);

        if ((path = b_string_new_len(tmp, len)) == NULL) {
            goto leave;
        }
    }

leave:
    PUTBACK;

    FREETMPS;
    LEAVE;

    return path;
}

static void builder_warn(b_error *err) {
    if (err == NULL) return;

    warn("%s: %s: %s", b_error_path(err)->str, b_error_message(err)->str, strerror(b_error_errno(err)));
}

static int find_flags(enum b_builder_options options) {
    int flags = 0;

    if (options & B_BUILDER_FOLLOW_SYMLINKS) {
        flags |= B_FIND_FOLLOW_SYMLINKS;
    }

    if (options & B_BUILDER_IGNORE_SOCKETS) {
        flags |= B_FIND_IGNORE_SOCKETS;
    }

    return flags;
}

#line 169 "src/Builder.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 313 "src/Builder.c"

XS_EUPXS(XS_Archive__Tar__Builder_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "klass, ...");
    {
	char *	klass = (char *)SvPV_nolen(ST(0))
;
	Archive__Tar__Builder	RETVAL;
#line 166 "src/Builder.xs"
        b_builder *builder;
        b_error *err;
        SV *cache = NULL;
        I32 i, retc;
        enum b_builder_options options = B_BUILDER_NONE;
        size_t block_factor = B_BUFFER_DEFAULT_FACTOR;

        if ((items - 1) % 2 != 0) {
            croak("Uneven number of arguments passed; must be in 'key' => 'value' format");
        }

        for (i=1; i<items; i+=2) {
            char *key = SvPV_nolen(ST(i));
            SV *value = ST(i+1);

            if (strcmp(key, "quiet")              == 0 && SvIV(value)) options |= B_BUILDER_QUIET;
            if (strcmp(key, "ignore_errors")      == 0 && SvIV(value)) options |= B_BUILDER_IGNORE_ERRORS;
            if (strcmp(key, "follow_symlinks")    == 0 && SvIV(value)) options |= B_BUILDER_FOLLOW_SYMLINKS;
            if (strcmp(key, "preserve_hardlinks") == 0 && SvIV(value)) options |= B_BUILDER_PRESERVE_HARDLINKS;
            if (strcmp(key, "gnu_extensions")     == 0 && SvIV(value)) options |= B_BUILDER_GNU_EXTENSIONS;
            if (strcmp(key, "posix_extensions")   == 0 && SvIV(value)) options |= B_BUILDER_PAX_EXTENSIONS;
            if (strcmp(key, "ignore_sockets")     == 0 && SvIV(value)) options |= B_BUILDER_IGNORE_SOCKETS;
            if (strcmp(key, "block_factor")       == 0 && SvIV(value)) block_factor = SvIV(value);
        }

        if ((builder = b_builder_new(block_factor)) == NULL) {
            croak("%s: %s", "b_builder_new()", strerror(errno));
        }

        b_builder_set_options(builder, options);

        err = b_builder_get_error(builder);

        if (!(options & B_BUILDER_QUIET)) {
            b_error_set_callback(err, B_ERROR_CALLBACK(builder_warn));
        }

        /*
         * Call Archive::Tar::Builder::UserCache->new()
         */
        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        XPUSHs(sv_2mortal(newSVpvf("Archive::Tar::Builder::UserCache")));
        PUTBACK;

        retc = call_method("new", G_SCALAR);

        SPAGAIN;

        if (retc == 1) {
            cache = POPs;
            SvREFCNT_inc(cache);
        }

        PUTBACK;
        FREETMPS;
        LEAVE;

        b_builder_set_user_lookup(builder, B_USER_LOOKUP(user_lookup), cache); 

        if (builder->options & B_BUILDER_PRESERVE_HARDLINKS) {
            /*
             * Call Archive::Tar::Builder::HardlinkCache->new()
             */
            ENTER;
            SAVETMPS;

            PUSHMARK(SP);
            XPUSHs(sv_2mortal(newSVpvf("Archive::Tar::Builder::HardlinkCache")));
            PUTBACK;

            retc = call_method("new", G_SCALAR);

            SPAGAIN;

            if (retc == 1) {
                cache = POPs;
                SvREFCNT_inc(cache);
            }

            PUTBACK;
            FREETMPS;
            LEAVE;

            b_builder_set_hardlink_cache(builder, B_HARDLINK_LOOKUP(hardlink_lookup), cache);
        }

        RETVAL = builder;

#line 417 "src/Builder.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Archive::Tar::Builder", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Tar__Builder_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "builder");
    {
	Archive__Tar__Builder	builder;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Archive::Tar::Builder::DESTROY",
			"builder")
;
#line 265 "src/Builder.xs"
        b_builder_destroy(builder);
#line 449 "src/Builder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Tar__Builder_include); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_include)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "builder, pattern");
    {
	Archive__Tar__Builder	builder;
	const char *	pattern = (const char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::include",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 273 "src/Builder.xs"
        if (b_builder_include(builder, pattern) < 0) {
            croak("Cananot add inclusion pattern '%s' to list of inclusions: %s", pattern, strerror(errno));
        }
#line 483 "src/Builder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Tar__Builder_include_from_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_include_from_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "builder, file");
    {
	Archive__Tar__Builder	builder;
	const char *	file = (const char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::include_from_file",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 283 "src/Builder.xs"
        if (b_builder_include_from_file(builder, file) < 0) {
            croak("Cannot add items to inclusion list from file %s: %s", file, strerror(errno));
        }
#line 517 "src/Builder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Tar__Builder_exclude); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_exclude)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "builder, pattern");
    {
	Archive__Tar__Builder	builder;
	const char *	pattern = (const char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::exclude",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 293 "src/Builder.xs"
        if (b_builder_exclude(builder, pattern) < 0) {
            croak("Cannot add exclusion pattern '%s' to list of exclusions: %s", pattern, strerror(errno));
        }
#line 551 "src/Builder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Tar__Builder_exclude_from_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_exclude_from_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "builder, file");
    {
	Archive__Tar__Builder	builder;
	const char *	file = (const char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::exclude_from_file",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 303 "src/Builder.xs"
        if (b_builder_exclude_from_file(builder, file) < 0) {
            croak("Cannot add items to exclusion list from file %s: %s", file, strerror(errno));
        }
#line 585 "src/Builder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Tar__Builder_is_excluded); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_is_excluded)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "builder, path");
    {
	Archive__Tar__Builder	builder;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::is_excluded",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 313 "src/Builder.xs"
        RETVAL = b_builder_is_excluded(builder, path);

#line 620 "src/Builder.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Tar__Builder_set_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_set_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "builder, fh");
    {
	Archive__Tar__Builder	builder;
	PerlIO *	fh = IoIFP(sv_2io(ST(1)))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::set_handle",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 324 "src/Builder.xs"
        b_buffer *buf = b_builder_get_buffer(builder);;

        b_buffer_set_fd(buf, PerlIO_fileno(fh));
#line 656 "src/Builder.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Tar__Builder_archive_as); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_archive_as)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "builder, ...");
    {
	Archive__Tar__Builder	builder;
	size_t	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::archive_as",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 333 "src/Builder.xs"
        enum b_builder_options options = b_builder_get_options(builder);
        b_buffer *buf = b_builder_get_buffer(builder);

        size_t i;

        if ((items - 1) % 2 != 0) {
            croak("Uneven number of arguments passed; must be in 'path' => 'member_name' format");
        }

        if (b_buffer_get_fd(buf) == 0) {
            croak("No file handle set");
        }

        for (i=1; i<items; i+=2) {
            int flags = find_flags(options);

            b_string *path        = b_string_new(SvPV_nolen(ST(i)));
            b_string *member_name = b_string_new(SvPV_nolen(ST(i+1)));

            if (b_find(builder, path, member_name, B_FIND_CALLBACK(b_builder_write_file), flags) < 0) {
                b_error * err         = b_builder_get_error(builder);
                b_string * error_path = b_error_path(err);

                if (error_path == NULL) {
                    error_path = path;
                }

                croak("%s: %s: %s\n", "b_find()", error_path->str, strerror(errno));
            }
        }

        RETVAL = builder->total;

#line 720 "src/Builder.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Tar__Builder_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "builder");
    {
	Archive__Tar__Builder	builder;
	ssize_t	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::flush",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 374 "src/Builder.xs"
        ssize_t ret;

        b_buffer *buf = b_builder_get_buffer(builder);

        if (b_buffer_get_fd(buf) == 0) {
            croak("No file handle set");
        }

        if ((ret = b_buffer_flush(buf)) < 0) {
            croak("%s: %s", "b_buffer_flush()", strerror(errno));
        }

        RETVAL = ret;

#line 767 "src/Builder.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Tar__Builder_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Tar__Builder_finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "builder");
    {
	Archive__Tar__Builder	builder;
	ssize_t	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Archive::Tar::Builder")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    builder = INT2PTR(Archive__Tar__Builder,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Archive::Tar::Builder::finish",
			"builder", "Archive::Tar::Builder",
			refstr, ST(0)
		);
	}
;
#line 396 "src/Builder.xs"
        ssize_t ret;

        b_buffer *buf = b_builder_get_buffer(builder);
        b_error *err  = b_builder_get_error(builder);

        enum b_builder_options options = b_builder_get_options(builder);

        if (b_buffer_get_fd(buf) == 0) {
            croak("No file handle set");
        }

        if ((ret = b_buffer_flush(buf)) < 0) {
            croak("%s: %s", "b_buffer_flush()", strerror(errno));
        }

        if (b_error_warn(err) && !(options & B_BUILDER_IGNORE_ERRORS)) {
            croak("Delayed nonzero exit status");
        }

        b_error_reset(err);

        RETVAL = ret;

#line 823 "src/Builder.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Archive__Tar__Builder); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Archive__Tar__Builder)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Archive::Tar::Builder::new", XS_Archive__Tar__Builder_new);
        newXS_deffile("Archive::Tar::Builder::DESTROY", XS_Archive__Tar__Builder_DESTROY);
        newXS_deffile("Archive::Tar::Builder::include", XS_Archive__Tar__Builder_include);
        newXS_deffile("Archive::Tar::Builder::include_from_file", XS_Archive__Tar__Builder_include_from_file);
        newXS_deffile("Archive::Tar::Builder::exclude", XS_Archive__Tar__Builder_exclude);
        newXS_deffile("Archive::Tar::Builder::exclude_from_file", XS_Archive__Tar__Builder_exclude_from_file);
        newXS_deffile("Archive::Tar::Builder::is_excluded", XS_Archive__Tar__Builder_is_excluded);
        newXS_deffile("Archive::Tar::Builder::set_handle", XS_Archive__Tar__Builder_set_handle);
        newXS_deffile("Archive::Tar::Builder::archive_as", XS_Archive__Tar__Builder_archive_as);
        newXS_deffile("Archive::Tar::Builder::flush", XS_Archive__Tar__Builder_flush);
        newXS_deffile("Archive::Tar::Builder::finish", XS_Archive__Tar__Builder_finish);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
